## つくりながら学ぶ! Python による因果分析 ~因果推論・因果探索の実践入門

<div align="center">
<img src="./etc/book.jpg" alt="" title="" width=30%>
</div>

<br>

[書籍「つくりながら学ぶ! Python による因果分析 ~因果推論・因果探索の実践入門」（小川雄太郎、マイナビ出版 、20/06/30) ](https://www.amazon.co.jp/dp/4839973571/)

のサポートリポジトリです。

<br>

### 1. 本書で扱う内容

本書の概要を以下の記事で解説しております。

[「Python による因果推論と因果探索（初心者の方向け）」](https://qiita.com/sugulu/items/2cffb239b44853b07f70)

<br>

**本書の目次**

- 第 1 章　相関と因果の違いを理解しよう
- 第 2 章　因果効果の種類を把握しよう
- 第 3 章　グラフ表現とバックドア基準を理解しよう
- 第 4 章　因果推論を実装しよう
  - 4-1 　回帰分析による因果推論の実装
  - 4-2 　傾向スコアを用いた逆確率重み付け法（IPTW）の実装
  - 4-3 　 Doubly Robust 法（DR 法）による因果推論の実装
- 第 5 章　機械学習を用いた因果推論
  - 5-1 　ランダムフォレストによる分類と回帰のしくみ
  - 5-2 　 Meta-Learners（T-Learner、S-Learner、X-Learner）の実装
  - 5-3 　 Doubly Robust Learning の実装
- 第 6 章　 LiNGAM の実装
  - 6-1 　 LiNGAM（Linear Non-Gaussian Acyclic Model）とは
  - 6-2 　独立成分分析とは
  - 6-3 　 LiNGAM による因果探索の実装
- 第 7 章　ベイジアンネットワークの実装
  - 7-1 　ベイジアンネットワークとは
  - 7-2 　ネットワークの当てはまりの良さを測る方法
  - 7-3 　変数間の独立性の検定
  - 7-4 　３タイプのベイジアンネットワークの探索手法
  - 7-5 　 PC アルゴリズムによるベイジアンネットワーク探索の実装
- 第 8 章　ディープラーニングを用いた因果探索
  - 8-1 　因果探索と GAN（Generative Adversarial Networks）の関係
  - 8-2 　 SAM（Structural Agnostic Model）の概要
  - 8-3 　 SAM の識別器 D と生成器 G の実装
  - 8-4 　 SAM の損失関数の解説と因果探索の実装
  - 8-5 　 Google Colaboratory で GPU を使用した因果探索の実行

<br>

### 2. 疑問点・修正点は Issue にて管理しています

本 GitHub の Issue にて、疑問点や修正点を管理しています。

不明な点などがございましたら、こちらをご覧ください。

https://github.com/YutaroOgawa/causal_book/issues

<br>

### 3. 誤植について

書籍中の誤植一覧はこちらになります。
大変申し訳ございません。

[誤植一覧](https://github.com/YutaroOgawa/causal_book/labels/%E8%AA%A4%E6%A4%8D)
